summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorAlexander Huemer <alexander.huemer@sbg.ac.at>2009-05-26 18:16:40 +0200
committerAlexander Huemer <alexander.huemer@sbg.ac.at>2009-05-26 18:16:40 +0200
commit2e6ed2fed19223406dd4aee18577608a7a885230 (patch)
tree8afb98d2f2c17c443c07e815d1dae89c58017830 /dev-lang
parentNew: app-text/enchant (diff)
downloadmultilib-portage-2e6ed2fed19223406dd4aee18577608a7a885230.tar.gz
multilib-portage-2e6ed2fed19223406dd4aee18577608a7a885230.tar.bz2
multilib-portage-2e6ed2fed19223406dd4aee18577608a7a885230.zip
bumped dev-lang/python:2.5 to latest ~ (2.5.4-r3). the ebuild was completely rewritten. hopefully i catched everything
Diffstat (limited to 'dev-lang')
-rw-r--r--dev-lang/python/Manifest2
-rw-r--r--dev-lang/python/python-2.5.4-r3.ebuild269
2 files changed, 271 insertions, 0 deletions
diff --git a/dev-lang/python/Manifest b/dev-lang/python/Manifest
index 8c84c173f..a69b797e9 100644
--- a/dev-lang/python/Manifest
+++ b/dev-lang/python/Manifest
@@ -21,10 +21,12 @@ DIST Python-2.5.4.tar.bz2 9821313 RMD160 3a76c83464c3b1c38a60351ab054e33ac719566
DIST Python-2.6.1.tar.bz2 10960385 RMD160 497dafaca9c150fca611b0175eeb13c2fc4d3e2d SHA1 419f0cb29e9713ea861dde8c43d107c51329e57b SHA256 cf153f10ba6312a8303ceb01bed834a2786d28aa89c7d73dba64714f691628f6
DIST Python-2.6.2.tar.bz2 11156901 RMD160 85fa3540cbacf4d0547d2381eb3aa76bef35c2e1 SHA1 125d4ed90f82de1d44f288150bbbda23a6cd27a4 SHA256 a1cdc4a8f6c1f947ea3b87d097af2db4371019bac941d92c3844124c5694328b
DIST python-gentoo-patches-2.5.2-r7.tar.bz2 28160 RMD160 c2a8c71f464f1cf0cd8e3d142a3f3454de46bc55 SHA1 b64fc90f331e42ea2c364fd61d13b515300fdcbf SHA256 8afff4ed12c3c5ca4418da657617317a8c646a69ae341a3d494747659825355f
+DIST python-gentoo-patches-2.5.4-r1.tar.bz2 20485 RMD160 f8e2d19fe0ad7b2176795c159768c406d3a08801 SHA1 62565a95ab46e9bf8ac20318d1c662ce44230949 SHA256 0d502be02d16c2acdf82aba14909d8c1201091bb696456ec3542fc58466e8655
DIST python-gentoo-patches-2.5.4.tar.bz2 19474 RMD160 00bb0918414db251b11b7f19a9f8a112c9e49fbd SHA1 fd4955f7da3049abecc4df0e203e783a90390cf8 SHA256 6e050dd8e8a90655bf935af99ad1ae6456bc072f075ddb9bcd532201bbb37274
DIST python-gentoo-patches-2.6-r5.tar.bz2 7431 RMD160 dbfc0715773446614843b45818d4152ca133140a SHA1 495cbfbf333052faf6860cf2d682f249a787557c SHA256 ef81eac97d933c77afcfd2434f44132717cd0a1550d1092e388e3c2f3dd5f3cf
DIST python-gentoo-patches-2.6.2.tar.bz2 8848 RMD160 e3cf700fd8966a6bd6e3e4b64534b72e56863819 SHA1 e073af86f27db77d2eb396ff78814f2b8920811b SHA256 9178be1a77893dc2c74e40073095bbc560d02e5456f1e6be6da20930470950f7
EBUILD python-2.5.2-r7.ebuild 10730 RMD160 93627852adbd2e41c4e5342840ca2b49f2a98405 SHA1 2eb26b8b69f62d5d981c79f6ea7e3a79b7884741 SHA256 986687608226bff47761fb44210e158a83badff0a856fbf89cdb360e0b846e35
EBUILD python-2.5.4-r2.ebuild 10879 RMD160 7b6c6cf457995a87c35a1b099391fdca0b94dd59 SHA1 8e2e25d0d7acbca8584c72bb6761be11e51aa15d SHA256 70b58fcc55db7e66e5944e2361b9fb585a1879b722acc76b749f19649d523807
+EBUILD python-2.5.4-r3.ebuild 8754 RMD160 b0102e9482ac2afbaf896f236e65cb5e56bdf2db SHA1 920237ecdea9d6215b708e81c640674a624fdbef SHA256 0968fc938eee756c0765c597776f590f5a0263131f6479349f2ca86c4c4278fb
EBUILD python-2.6.1-r1.ebuild 9268 RMD160 8fe543b70cdf557b504e21b31e0cc6acd111c7ee SHA1 9851b055d3667e49a86449db076e97efca0441a5 SHA256 21570141e43249e646e3a120c4ee47d85f9b2b10b286783192265b0a04bb4e3f
EBUILD python-2.6.2.ebuild 8807 RMD160 65c8f5acdbb991181afb84722d1b046b2d783a41 SHA1 2157346cd4d5fc574c2b77e5216a8bd6155a53df SHA256 3d0e4bd59cd6e29e1abfa84e0d5e9a8b8363cc5b4995693ee2c69c1b86eb61d8
diff --git a/dev-lang/python/python-2.5.4-r3.ebuild b/dev-lang/python/python-2.5.4-r3.ebuild
new file mode 100644
index 000000000..79a72724f
--- /dev/null
+++ b/dev-lang/python/python-2.5.4-r3.ebuild
@@ -0,0 +1,269 @@
+# Copyright 1999-2009 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/dev-lang/python/python-2.5.4-r3.ebuild,v 1.1 2009/05/25 17:11:18 arfrever Exp $
+
+# NOTE about python-portage interactions :
+# - Do not add a pkg_setup() check for a certain version of portage
+# in dev-lang/python. It _WILL_ stop people installing from
+# Gentoo 1.4 images.
+
+EAPI=2
+
+MULTILIB_IN_SOURCE_BUILD="yes"
+
+inherit eutils autotools flag-o-matic python versionator toolchain-funcs libtool multilib-native
+
+# We need this so that we don't depend on python.eclass
+PYVER_MAJOR=$(get_major_version)
+PYVER_MINOR=$(get_version_component_range 2)
+PYVER="${PYVER_MAJOR}.${PYVER_MINOR}"
+
+MY_P="Python-${PV}"
+S="${WORKDIR}/${MY_P}"
+
+DESCRIPTION="Python is an interpreted, interactive, object-oriented programming language."
+HOMEPAGE="http://www.python.org/"
+SRC_URI="http://www.python.org/ftp/python/${PV}/${MY_P}.tar.bz2
+ mirror://gentoo/python-gentoo-patches-${PV}-r1.tar.bz2"
+
+LICENSE="PSF-2.2"
+SLOT="2.5"
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~sparc-fbsd ~x86 ~x86-fbsd"
+IUSE="berkdb build doc elibc_uclibc examples gdbm ipv6 ncurses readline sqlite ssl +threads tk ucs2 wininst +xml"
+
+# NOTE: dev-python/{elementtree,celementtree,pysqlite,ctypes,cjkcodecs}
+# do not conflict with the ones in python proper. - liquidx
+
+DEPEND=">=app-admin/eselect-python-20080925
+ >=sys-libs/zlib-1.1.3[lib32?]
+ !build? (
+ sqlite? ( >=dev-db/sqlite-3[lib32?] )
+ tk? ( >=dev-lang/tk-8.0[lib32?] )
+ ncurses? ( >=sys-libs/ncurses-5.2[lib32?]
+ readline? ( >=sys-libs/readline-4.1[lib32?] ) )
+ berkdb? ( || ( sys-libs/db:4.5[lib32?] sys-libs/db:4.4[lib32?] sys-libs/db:4.3[lib32?]
+ sys-libs/db:4.2[lib32?] ) )
+ gdbm? ( sys-libs/gdbm[lib32?] )
+ ssl? ( dev-libs/openssl[lib32?] )
+ doc? ( dev-python/python-docs:${SLOT} )
+ xml? ( dev-libs/expat[lib32?] )
+ )"
+
+RDEPEND="${DEPEND}"
+PDEPEND="${DEPEND} app-admin/python-updater"
+
+PROVIDE="virtual/python"
+
+multilib-native_src_prepare_internal() {
+
+ if tc-is-cross-compiler; then
+ epatch "${FILESDIR}"/python-2.4.4-test-cross.patch \
+ "${FILESDIR}"/python-2.5-cross-printf.patch
+ else
+ rm "${WORKDIR}/${PV}"/*_all_crosscompile.patch
+ fi
+
+ epatch "${FILESDIR}"/${P}-distutils-multilib.patch
+
+ EPATCH_SUFFIX="patch" epatch "${WORKDIR}/${PV}"
+
+ sed -i -e "s:@@GENTOO_LIBDIR@@:$(get_libdir):g" \
+ Lib/distutils/command/install.py \
+ Lib/distutils/sysconfig.py \
+ Lib/site.py \
+ Makefile.pre.in \
+ Modules/Setup.dist \
+ Modules/getpath.c \
+ setup.py || die "sed failed to replace @@GENTOO_LIBDIR@@"
+
+ # fix os.utime() on hppa. utimes it not supported but unfortunately reported as working - gmsoft (22 May 04)
+ # PLEASE LEAVE THIS FIX FOR NEXT VERSIONS AS IT'S A CRITICAL FIX !!!
+ [[ "${ARCH}" == "hppa" ]] && sed -e "s/utimes //" -i "${S}/configure"
+
+ if ! use wininst; then
+ # Remove Microsoft Windows executables.
+ rm Lib/distutils/command/wininst-*.exe
+ fi
+
+ eautoreconf
+}
+
+multilib-native_src_configure_internal() {
+ # Disable extraneous modules with extra dependencies.
+ if use build; then
+ export PYTHON_DISABLE_MODULES="readline pyexpat dbm gdbm bsddb _curses _curses_panel _tkinter _sqlite3"
+ export PYTHON_DISABLE_SSL=1
+ else
+ # dbm module can link to berkdb or gdbm
+ # Defaults to gdbm when both are enabled, #204343
+ local disable
+ use berkdb || use gdbm || disable="${disable} dbm"
+ use berkdb || disable="${disable} bsddb"
+ use xml || disable="${disable} pyexpat"
+ use gdbm || disable="${disable} gdbm"
+ use ncurses || disable="${disable} _curses _curses_panel"
+ use readline || disable="${disable} readline"
+ use sqlite || disable="${disable} _sqlite3"
+ use ssl || export PYTHON_DISABLE_SSL=1
+ use tk || disable="${disable} _tkinter"
+ export PYTHON_DISABLE_MODULES="${disable}"
+ fi
+
+ if ! use xml; then
+ ewarn "You have configured Python without XML support."
+ ewarn "This is NOT a recommended configuration as you"
+ ewarn "may face problems parsing any XML documents."
+ fi
+
+ einfo "Disabled modules: $PYTHON_DISABLE_MODULES"
+
+ export OPT="${CFLAGS}"
+
+ local myconf
+
+ # Super-secret switch. Don't use this unless you know what you're
+ # doing. Enabling UCS2 support will break your existing python
+ # modules
+ use ucs2 \
+ && myconf="${myconf} --enable-unicode=ucs2" \
+ || myconf="${myconf} --enable-unicode=ucs4"
+
+ filter-flags -malign-double
+
+ [[ "${ARCH}" == "alpha" ]] && append-flags -fPIC
+
+ # http://bugs.gentoo.org/show_bug.cgi?id=50309
+ if is-flag -O3; then
+ is-flag -fstack-protector-all && replace-flags -O3 -O2
+ use hardened && replace-flags -O3 -O2
+ fi
+
+ if tc-is-cross-compiler; then
+ OPT="-O1" CFLAGS="" LDFLAGS="" CC="" \
+ ./configure --{build,host}=${CBUILD} || die "cross-configure failed"
+ emake python Parser/pgen || die "cross-make failed"
+ mv python hostpython
+ mv Parser/pgen Parser/hostpgen
+ make distclean
+ sed -i \
+ -e "/^HOSTPYTHON/s:=.*:=./hostpython:" \
+ -e "/^HOSTPGEN/s:=.*:=./Parser/hostpgen:" \
+ Makefile.pre.in || die "sed failed"
+ fi
+
+ # Export CXX so it ends up in /usr/lib/python2.x/config/Makefile.
+ tc-export CXX
+
+ # Set LDFLAGS so we link modules with -lpython2.5 correctly.
+ # Needed on FreeBSD unless Python 2.5 is already installed.
+ # Please query BSD team before removing this!
+ append-ldflags "-L."
+
+ econf \
+ --with-fpectl \
+ --enable-shared \
+ $(use_enable ipv6) \
+ $(use_with threads) \
+ --infodir='${prefix}'/share/info \
+ --mandir='${prefix}'/share/man \
+ --with-libc='' \
+ ${myconf}
+}
+
+multilib-native_src_compile_internal() {
+ src_configure
+ emake || die "emake failed"
+}
+
+src_test() {
+ # Tests won't work when cross compiling
+ if tc-is-cross-compiler ; then
+ elog "Disabling tests due to crosscompiling."
+ return
+ fi
+
+ # Disabling byte compiling breaks test_import
+ python_enable_pyc
+
+ #Skip all tests that fail during emerge but pass without emerge:
+ #(See bug# 67970)
+ local skip_tests="distutils global mimetools minidom mmap posix pyexpat sax strptime subprocess syntax tcl time urllib urllib2 webbrowser xml_etree"
+
+ # test_pow fails on alpha.
+ # http://bugs.python.org/issue756093
+ [[ ${ARCH} == "alpha" ]] && skip_tests="${skip_tests} pow"
+
+ for test in ${skip_tests} ; do
+ mv "${S}"/Lib/test/test_${test}.py "${T}"
+ done
+
+ # Redirect stdin from /dev/tty as a workaround for bug #248081.
+ # rerun failed tests in verbose mode (regrtest -w)
+ EXTRATESTOPTS="-w" make test < /dev/tty || die "make test failed"
+
+ for test in ${skip_tests} ; do
+ mv "${T}"/test_${test}.py "${S}"/Lib/test/test_${test}.py
+ done
+
+ elog "Portage skipped the following tests which aren't able to run from emerge:"
+ for test in ${skip_tests} ; do
+ elog "test_${test}.py"
+ done
+
+ elog "If you'd like to run them, you may:"
+ elog "cd /usr/$(get_libdir)/python${PYVER}/test"
+ elog "and run the tests separately."
+}
+
+multilib-native_src_install_internal() {
+ emake DESTDIR="${D}" altinstall maninstall || die "emake altinstall maninstall failed"
+
+ mv "${D}"/usr/bin/python${PYVER}-config "${D}"/usr/bin/python-config-${PYVER}
+ if [[ $(number_abis) -gt 1 ]] && ! is_final_abi; then
+ mv "${D}"/usr/bin/python${PYVER} "${D}"/usr/bin/python${PYVER}-${ABI}
+ fi
+
+ # Fix slotted collisions
+ mv "${D}"/usr/bin/pydoc "${D}"/usr/bin/pydoc${PYVER}
+ mv "${D}"/usr/bin/idle "${D}"/usr/bin/idle${PYVER}
+ mv "${D}"/usr/share/man/man1/python.1 "${D}"/usr/share/man/man1/python${PYVER}.1
+ rm -f "${D}"/usr/bin/smtpd.py
+
+ # Fix the OPT variable so that it doesn't have any opts listed in it.
+ # Prevents the problem with compiling things with conflicting flags later.
+ sed -e "s:^OPT=.*:OPT=-DNDEBUG:" -i "${D}/usr/$(get_libdir)/python${PYVER}/config/Makefile"
+
+ if use build ; then
+ rm -rf "${D}"/usr/$(get_libdir)/python${PYVER}/{test,encodings,email,lib-tk,bsddb/test}
+ else
+ use elibc_uclibc && rm -fr "${D}"/usr/$(get_libdir)/python${PYVER}/{test,bsddb/test}
+ use berkdb || rm -fr "${D}"/usr/$(get_libdir)/python${PYVER}/bsddb
+ use tk || rm -fr "${D}"/usr/$(get_libdir)/python${PYVER}/lib-tk
+ fi
+
+ prep_ml_includes usr/include/python${PYVER}
+
+ if use examples ; then
+ insinto /usr/share/doc/${PF}/examples
+ doins -r "${S}"/Tools || die "doins failed"
+ fi
+
+ newinitd "${FILESDIR}/pydoc.init" pydoc-${SLOT}
+ newconfd "${FILESDIR}/pydoc.conf" pydoc-${SLOT}
+}
+
+pkg_postrm() {
+ eselect python update --ignore 3.0
+
+ python_mod_cleanup /usr/lib/python${PYVER}
+ [[ "$(get_libdir)" != "lib" ]] && python_mod_cleanup /usr/$(get_libdir)/python${PYVER}
+}
+
+pkg_postinst() {
+ eselect python update --ignore 3.0
+
+ python_mod_optimize -x "(site-packages|test)" /usr/lib/python${PYVER}
+ [[ "$(get_libdir)" != "lib" ]] && python_mod_optimize -x "(site-packages|test)" /usr/$(get_libdir)/python${PYVER}
+}
+
+